#include "stdafx.h"
#include <string.h>
#include <time.h>

struct smb
{
	char* name;
	char* contract;
	FILE* out;
};

void GetFile(char*, smb*);
int	 GetFields(int, char**, char*);
time_t StrToTime(char*);
int	StrToInteger(char*);

int _tmain(int argc, _TCHAR* argv[])
{
	char fname[256];
	smb Symbol[9]={	{"EURUSD","099741 "},{"GBPUSD","096742 "},{"USDCAD","090741 "},
					{"USDJPY","097741 "},{"AUDUSD","232741 "},{"NZDUSD","112741 "},
					{"USDCHF","092741 "},{"XAUUSD","088691 "},{"XAGUSD","084691 "}	};
	for(int i=0;i<9;i++)
	{
		fname[0]=0; strcat_s(fname,Symbol[i].name); strcat_s(fname,"G3.cot");
		fopen_s(&Symbol[i].out,fname,"wb"); 
		if(Symbol[i].out==NULL) printf("Can`t open %s\n", fname);
		else printf("Opened %s\t for writing\n", fname);
	}
	GetFile("annual.txt",Symbol); GetFile("annual12.txt",Symbol); GetFile("FUT86_11.txt",Symbol);
	_fcloseall();
	return 0;
}

void GetFile(char* fname, smb* Symbol)
{
	time_t from_t=StrToTime("2000-01-01"), report_t;
	int data[8]; //    : ,  , nl, ns, cl, cs, ol, os
	char buf[5000], *Field[129];
	FILE* in;
	fopen_s(&in,fname,"r"); 
	if(in==NULL) { printf("Can`t open %s\n", fname); return; }
	else printf("Opened %s\t for reading\n", fname);
	fgets(buf,5000,in); //     
	while(fgets(buf,5000,in)!=NULL)
	{
		if(!GetFields(17,Field,buf)) { printf("Can`t get %d fields",17); continue; }
		report_t=StrToTime(Field[2]); if(report_t<from_t) continue; //  
		for(int i=0;i<9;i++) if(strcmp(Field[3],Symbol[i].contract)==0)
		{
			if(Symbol[i].out==NULL) break;
			data[0]=(int)report_t;			 data[1]=StrToInteger(Field[7]);
			data[2]=StrToInteger(Field[8]);	 data[3]=StrToInteger(Field[9]);
			data[4]=StrToInteger(Field[11]); data[5]=StrToInteger(Field[12]);
			data[6]=StrToInteger(Field[15]); data[7]=StrToInteger(Field[16]);
			fwrite(data, sizeof(int),8,Symbol[i].out);
			break;
		}
	}
}


int GetFields(int n, char* Field[], char* buf)
{
	char* begin=buf;
	int quotes=false, len=strlen(buf), cnt=0;
	for(int i=0;i<len;i++)
	{
		if(buf[i]=='\"') quotes=!quotes;
		if(!quotes) if(buf[i]==',' || buf[i]=='\n')
		{
			buf[i]=0; Field[cnt++]=begin; begin=buf+i+1;
			if(cnt==n) return 1;
		}
	}
	return 0;
}

time_t StrToTime(char *stime)
{
	tm t; memset(&t,0,sizeof(t));
	sscanf_s(stime,"%d-%d-%d",&t.tm_year,&t.tm_mon,&t.tm_mday);
	t.tm_year-=1900; t.tm_mon--;
	return _mkgmtime(&t);
}

int StrToInteger(char *sint)
{
	int res=0;
	sscanf_s(sint,"%d",&res);
	return res;
}
